package MT::Plugin::PrevNextInCategory;
use strict;
use MT;
use MT::Plugin;
use MT::Tag;

our $VERSION = '0.1';

use base qw( MT::Plugin );

@MT::Plugin::PrevNextInCategory::ISA = qw(MT::Plugin);

my $plugin = new MT::Plugin::PrevNextInCategory({
    name => 'PrevNextInCategory',
    description => '<MT_TRANS phrase=\'_PLUGIN_DESCRIPTION\'>',
    author_name => 'Alfasado, Inc.',
    author_link => 'http://alfasado.net/',
    version     => $VERSION,
    l10n_class => 'PrevNextInCategory::L10N',
});

MT->add_plugin($plugin);

sub init_registry {
    my $plugin = shift;
    $plugin->registry({
        tags => {
            block => {
                'EntryPreviousInCategory' => \&_hdlr_entry_previous_in_category,
                'EntryNextInCategory' => \&_hdlr_entry_next_in_category,
            },
        },
   });
}

sub _hdlr_entry_previous_in_category {
    my ( $ctx, $args, $cond ) = @_;
    _hdlr_entry_nextprev('previous', @_);
}

sub _hdlr_entry_next_in_category {
    my ( $ctx, $args, $cond ) = @_;
    _hdlr_entry_nextprev('next', @_);
}

sub _hdlr_entry_nextprev {
    my( $meth, $ctx, $args, $cond ) = @_;
    my $e = $ctx->stash('entry')
        or return $ctx->_no_entry_error($ctx->stash('tag'));
    my $terms = { status => MT::Entry::RELEASE() };
    $terms->{by_category} = 1 ;
    my $entry = $e->$meth($terms);
    my $res = '';
    if ($entry) {
        my $builder = $ctx->stash('builder');
        local $ctx->{__stash}->{entry} = $entry;
        local $ctx->{current_timestamp} = $entry->authored_on;
        my $out = $builder->build($ctx, $ctx->stash('tokens'), $cond);
        return $ctx->error( $builder->errstr ) unless defined $out;
        $res .= $out;
    }
    $res;
}

1;